<?php
/**
 * webEdition CMS
 *
 * $Rev: 15093 $
 * $Author: mokraemer $
 * $Date: 2018-03-21 12:07:05 +0100 (Wed, 21 Mar 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
/* this file contains vertical tabs
 * it has variables:
 * - $allTabs => array of all tabnames
 * - $activeTab => current selected tab
 */

// initialise tabs
$tabs = new we_gui_tabs();
$tabs->addTab(g_l('liveUpdate', '[tabs][update]'), 'fa-recycle', ($this->Data['activeTab'] == 'update'), "'update'");
$tabs->addTab(g_l('liveUpdate', '[tabs][languages]'), 'fa-language', ($this->Data['activeTab'] == 'languages'), "'languages'");
$tabs->addTab(g_l('liveUpdate', '[tabs][updatelog]'), 'fa-list-alt', ($this->Data['activeTab'] == 'updatelog'), "'updatelog'");
$tabs->addTab(g_l('liveUpdate', '[tabs][connect]'), 'fa-handshake-o', ($this->Data['activeTab'] == 'connect'), "'connect'");
$tabs->addTab(g_l('liveUpdate', '[tabs][beta]'), 'fa-unlock-alt', ($this->Data['activeTab'] == 'beta'), "'beta'");

// get output

return we_html_tools::getHtmlTop('', '', '', we_html_element::cssLink(CSS_DIR . 'we_tab.css') .
		we_html_element::jsScript(JS_DIR . 'initTabs.js') .
		we_html_element::jsScript(JS_DIR . 'update/updatelog.js'), we_html_element::body([
			'id' => 'eHeaderBody',
			'onload' => 'weTabs.setFrameSize();',
			'onresize' => 'weTabs.setFrameSize()'
			], we_html_element::div(['id' => "main"], $tabs->getHTML()))
);
