<?php
/**
 * webEdition CMS
 *
 * $Rev: 15093 $
 * $Author: mokraemer $
 * $Date: 2018-03-21 12:07:05 +0100 (Wed, 21 Mar 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
return [
	'new' => [
		'text' => g_l('searchtool', '[menu_new]'),
		'icon' => 'fa fa-plus-circle',
	],
	['text' => g_l('searchtool', '[forDocuments]'),
		'parent' => 'new',
		'cmd' => 'weSearch_new_forDocuments',
		'perm' => [we_base_perm::WORK_DOCUMENTS_CAN_SEE],
	],
	['text' => g_l('searchtool', '[forTemplates]'),
		'parent' => 'new',
		'cmd' => 'weSearch_new_forTemplates',
		'perm' => [we_base_perm::WORK_TEMPLATES_CAN_SEE],
	],
	['text' => g_l('searchtool', '[forObjects]'),
		'parent' => 'new',
		'cmd' => 'weSearch_new_forObjects',
		'perm' => [we_base_perm::OBJECTFILES_CAN_SEE],
	],
	['text' => g_l('searchtool', '[forMedia]'),
		'parent' => 'new',
		'cmd' => 'weSearch_new_forMedia',
	],
	['text' => g_l('searchtool', '[menu_advSearch]'),
		'parent' => 'new',
		'cmd' => 'weSearch_new_advSearch',
		'perm' => [we_base_perm::ADMINISTRATOR],
	],
	'search' => [
		'text' => g_l('searchtool', '[menu_suche]'),
		'icon' => 'fa fa-search'
	],
	['text' => g_l('searchtool', '[menu_save]'),
		'parent' => 'search',
		'cmd' => 'weSearch_save',
	],
	['text' => g_l('searchtool', '[menu_delete]'),
		'parent' => 'search',
		'cmd' => 'weSearch_delete',
	],
	['parent' => 'search'], // separator
	['text' => g_l('searchtool', '[menu_exit]'),
		'parent' => 'search',
		'cmd' => 'weSearch_exit',
	],
];
