<?php
/**
 * //NOTE you are inside the constructor of we_tagData_base.class.php
 * webEdition CMS
 *
 * $Rev: 15889 $
 * $Author: mokraemer $
 * $Date: 2018-10-08 15:31:17 +0200 (Mon, 08 Oct 2018) $
 */
$this->NeedsEndTag = true;
$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);

$id = new we_tagData_selectorAttribute('id', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT);
$name = new we_tagData_textAttribute('name', false, '');
$nameid = new we_tagData_textAttribute('nameid', false, '');
$method = new we_tagData_selectAttribute('method', [new we_tagData_option('get'),
	new we_tagData_option('post'),
	], false, '');
$target = new we_tagData_choiceAttribute('target', [new we_tagData_option('_top'),
	new we_tagData_option('_parent'),
	new we_tagData_option('_self'),
	new we_tagData_option('_blank'),
	], false, false);
$recipient = new we_tagData_textAttribute('recipient', true, '');
$onsuccess = new we_tagData_selectorAttribute('onsuccess', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT);
$onerror = new we_tagData_selectorAttribute('onerror', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT);
$onmailerror = new we_tagData_selectorAttribute('onmailerror', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT);
$onrecipienterror = new we_tagData_selectorAttribute('onrecipienterror', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT);
$from = new we_tagData_textAttribute('from');
$subject = new we_tagData_textAttribute('subject');
$charset = new we_tagData_textAttribute('charset');
$order = new we_tagData_textAttribute('order');
$required = new we_tagData_textAttribute('required');
$remove = new we_tagData_textAttribute('remove');
$mimetype = new we_tagData_selectAttribute('mimetype', [
	new we_tagData_option('text/plain'),
	new we_tagData_option('text/html'),
	]);
$confirmmail = new we_tagData_selectAttribute('confirmmail', we_tagData_selectAttribute::getTrueFalse());
$forcefrom = new we_tagData_selectAttribute('forcefrom', we_tagData_selectAttribute::getTrueFalse());
$preconfirm = new we_tagData_textAttribute('preconfirm');
$postconfirm = new we_tagData_textAttribute('postconfirm');
$doctype = new we_tagData_sqlRowAttribute('doctype', DOC_TYPES_TABLE, true, 'DocType', '', '');
$categories = new we_tagData_multiSelectorAttribute('categories', CATEGORY_TABLE, '', 'Path', false, we_modules_info::CATEGORY);
$tid = new we_tagData_selectorAttribute('tid', TEMPLATES_TABLE, we_base_ContentTypes::TEMPLATE);
$classid = new we_tagData_selectorAttribute('classid', OBJECT_TABLE, we_base_ContentTypes::OBJECT, false, we_modules_info::OBJECT);
$parentid = new we_tagData_selectorAttribute('parentid', OBJECT_FILES_TABLE, we_tagData_selectorAttribute::FOLDER, false, we_modules_info::OBJECT);
$xml = new we_tagData_selectAttribute('xml', we_tagData_selectAttribute::getTrueFalse());
$enctype = new we_tagData_selectAttribute('enctype', [new we_tagData_option('application/x-www-form-urlencoded'),
	new we_tagData_option('multipart/form-data'),
	]);
$params = new we_tagData_textAttribute('params');

if(defined('FORMMAIL_VIAWEDOC') && FORMMAIL_VIAWEDOC == 1){
	$this->TypeAttribute = new we_tagData_typeAttribute('type', [
		new we_tagData_option('-', false, '', [$id, $name, $nameid, $method, $target, $enctype], []),
		new we_tagData_option('document', false, '', [$id, $name, $nameid, $method, $target, $doctype, $tid, $enctype, $params], [$doctype]),
		new we_tagData_option('formmail', false, '', [$id, $name, $nameid, $method, $target, $recipient, $onsuccess, $onerror, $onmailerror, $onrecipienterror, $from,
			$subject, $charset, $order, $required, $remove, $mimetype, $confirmmail, $forcefrom, $preconfirm, $postconfirm, $params], [$recipient]),
		new we_tagData_option('object', false, we_modules_info::OBJECT, [$id, $name, $nameid, $method, $target, $categories, $classid, $parentid, $enctype, $params], [
			$classid]),
		new we_tagData_option('search', false, '', [$id, $name, $nameid, $method, $target, $params]),
		new we_tagData_option('shopliste', false, we_modules_info::SHOP, [$id, $nameid, $method, $target, $params])
		], false, '');
} else {
	$this->TypeAttribute = new we_tagData_typeAttribute('type', [
		new we_tagData_option('-', false, '', [$id, $name, $nameid, $method, $target, $enctype], []),
		new we_tagData_option('document', false, '', [$id, $name, $nameid, $method, $target, $doctype, $tid, $enctype, $params], [$doctype]),
		new we_tagData_option('formmail', false, '', [$name, $nameid, $method, $target, $recipient, $onsuccess, $onerror, $onmailerror, $onrecipienterror, $from, $subject,
			$charset, $order, $required, $remove, $mimetype, $confirmmail, $forcefrom, $preconfirm, $postconfirm, $params], [$recipient]),
		new we_tagData_option('object', false, we_modules_info::OBJECT, [$id, $name, $nameid, $method, $target, $categories, $classid, $parentid, $enctype, $params], [
			$classid]),
		new we_tagData_option('search', false, '', [$id, $name, $nameid, $method, $target, $params]),
		new we_tagData_option('shopliste', false, we_modules_info::SHOP, [$id, $nameid, $method, $target, $params])
		], false, '');
}


$this->Attributes = [$id, $name, $nameid, $method, $target, $params, $recipient, $onsuccess, $onerror, $onmailerror, $from, $subject, $charset, $order, $required,
	$remove,
	$mimetype,
	$confirmmail, $forcefrom, $preconfirm, $postconfirm, $doctype, $categories, $tid, $classid, $parentid, $xml, $enctype];
