<?php

/**
 * webEdition CMS
 *
 * $Rev: 15093 $
 * $Author: mokraemer $
 * $Date: 2018-03-21 12:07:05 +0100 (Wed, 21 Mar 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_chooser_multiFile extends we_chooser_multiDir{
	private $disabledDelItems = [];
	private $disabledDelReason = '';
	private $iconFile;
	private $iconFolder;

	public function __construct($width, $ids, $cmd_del, $addbut, $cmd_edit, $iconFolder = we_base_ContentTypes::FOLDER, $iconFile = we_base_ContentTypes::APPLICATION){
		parent::__construct($width, $ids, $cmd_del, $addbut);
		$this->iconFile = $iconFile;
		$this->iconFolder = $iconFolder;
		$this->cmd_edit = $cmd_edit;
	}

	public function setDisabledDelItems(array $items, $reason){
		$this->disabledDelItems = $items;
		$this->disabledDelReason = $reason;
	}

	function get(we_base_jsCmd $jsCmd){
		$table = new we_html_table(['class' => 'default', 'width' => '100%'], 1, 4);

		$this->nr = 0;
		$idArr = (is_array($this->ids) ? $this->ids : array_filter(explode(',', trim($this->ids, ','))));
		$c = 1;

		if($idArr){
			foreach($idArr as $id){
				$table->addRow();

				$edit = null;
				$trash = null;

				if($this->isEditable && $this->cmd_edit){
					$edit = we_html_button::create_button(we_html_button::OPEN_TO_EDIT, 'javascript:' . $this->getJsSetHot() . ";we_cmd('" . $this->cmd_edit . "','" . $id . "');");
				}

				if(($this->isEditable && $this->cmd_del) || $this->CanDelete){

					if($this->disabledDelItems){
						$DisArr = $this->disabledDelItems;
						if(in_array($id, $DisArr)){
							$trash = we_html_button::create_button(we_html_button::TRASH, 'javascript:' . $this->getJsSetHot() . ($this->extraDelFn ?: "") . ";we_cmd('" . $this->cmd_del . "','" . $id . "');", '', '', true);

							$table->setCol($c, 0, ['title' => $this->disabledDelReason, 'class' => 'chooserFileIcon', 'data-contenttype' => (is_dir($id) ? $this->iconFolder : $this->iconFile)], '');
							$table->setCol($c, 1, ['class' => $this->css, 'title' => $this->disabledDelReason], $id);
						} else {
							$trash = we_html_button::create_button(we_html_button::TRASH, 'javascript:' . $this->getJsSetHot() . ($this->extraDelFn ?: "") . ";we_cmd('" . $this->cmd_del . "','" . $id . "');");

							$table->setCol($c, 0, ['class' => 'chooserFileIcon', 'data-contenttype' => (is_dir($id) ? $this->iconFolder : $this->iconFile)], '');
							$table->setCol($c, 1, ['class' => $this->css], $id);
						}
					} else {
						$trash = we_html_button::create_button(we_html_button::TRASH, 'javascript:' . $this->getJsSetHot() . ($this->extraDelFn ?: "") . ";we_cmd('" . $this->cmd_del . "','" . $id . "');");

						$table->setCol($c, 0, ['class' => 'chooserFileIcon', 'data-contenttype' => (is_dir($id) ? $this->iconFolder : $this->iconFile)], '');
						$table->setCol($c, 1, ['class' => $this->css], $id);
					}
				} else {
					$trash = '';

					$table->setCol($c, 0, ['class' => 'chooserFileIcon', 'data-contenttype' => (is_dir($id) ? $this->iconFolder : $this->iconFile)], '');
					$table->setCol($c, 1, ['class' => $this->css], $id);
				}

				$table->setCol($c, 2, ['style' => 'text-align:right'], $edit . $trash);

				$c++;
			}
		}


		$table2 = new we_html_table(['class' => 'default multichooser', 'width' => $this->width], 1, 1);

		$table2->setColContent(0, 0, we_html_element::div(['class' => 'multichooser', 'id' => 'multi_selector', ($this->width ? 'style' : '') => 'width:' . $this->width . 'px'], $table->getHtml()));

		if($this->addbut){
			$table2->addRow();
			$table2->setCol(1, 0, ['class' => 'addButton'], $this->addbut);
		}
		$jsCmd->addCmd('setIconOfDocClass', 'chooserFileIcon');
		return $table2->getHtml();
	}

}
