<?php

/**
 * webEdition CMS
 *
 * $Rev: 15889 $
 * $Author: mokraemer $
 * $Date: 2018-10-08 15:31:17 +0200 (Mon, 08 Oct 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_dialog_addToCollection{

	public static function getDialog(){
		$table = we_base_request::_(we_base_request::TABLE, 'we_cmd', '', 2);
		$targetCollection = we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3);
		$targetCollectionPath = $targetCollection === 0 ? '/' : we_base_request::_(we_base_request::STRING, 'we_cmd', '/', 4);
		$disableTargetSelection = $targetCollection !== 0;
		$insertIndex = we_base_request::_(we_base_request::STRING, 'we_cmd', 0, 5);
		$insertPos = ($pos = we_base_request::_(we_base_request::INT, 'we_cmd', -1, 6)) !== -1 ? $pos : (we_base_request::_(we_base_request::INT, 'we_targetInsertPos', -1));
		$hideCheckRecursive = we_base_request::_(we_base_request::BOOL, 'we_cmd', false, 7);
		$presetRecursive = we_base_request::_(we_base_request::INT, 'we_cmd', 1, 8);

		/* FIXME: adapt when collection perms are implemented
		 *
		  if(($table == TEMPLATES_TABLE && !we_base_permission::hasPerm(we_base_perm::MOVE_TEMPLATE)) ||
		  ($table == FILE_TABLE && !we_base_permission::hasPerm(we_base_perm::MOVE_DOCUMENT)) ||
		  ($table == OBJECT_TABLE && !we_base_permission::hasPerm(we_base_perm::MOVE_OBJECTFILES))){
		  we_base_permission::noPermDialog(g_l('alert', '[no_perms]',false,true));
		  }
		 *
		 */
		$weSuggest = & we_gui_suggest::getInstance();
		$cmd0 = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 0);

		$ws_Id = get_def_ws($table);
		if($ws_Id){
			$ws_path = id_to_path($ws_Id, $table);
		} else {
			$ws_Id = 0;
			$ws_path = '/';
		}

		$textname = 'we_targetname';
		$idname = 'we_target';
		$weSuggest->setAcId('Dir');
		$weSuggest->setContentType([we_base_ContentTypes::FOLDER, we_base_ContentTypes::COLLECTION]);
		$weSuggest->setInput($textname, $targetCollectionPath, ($disableTargetSelection ? ['disabled' => 'disabled'] : []));
		//$weSuggest->setJsCommandOnItemSelect('select_collection_callback');
		$weSuggest->setMaxResults(4);
		$weSuggest->setRequired(true);
		$weSuggest->setResult($idname, $targetCollection);
		$weSuggest->setSelector(we_gui_suggest::DocSelector);
		$weSuggest->setTable(VFILE_TABLE);
		$weSuggest->setWidth(273);
		$weSuggest->setSelectButton(we_html_button::create_button(we_html_button::SELECT, "javascript:we_cmd('we_selector_document', document.we_form.elements." . $idname . ".value,WE().consts.tables.VFILE_TABLE,'" . $idname . "','" . $textname . "','','', 0)", '', '', $disableTargetSelection));
		// FIXME: btn open is not displayed because opening docs the normal way makes the tree reload without addToCollection-header
		//$weSuggest->setOpenButton(we_html_button::create_button(we_html_button::OPEN_TO_EDIT, "javascript:we_cmd('open_collection_to_edit');", '', '', true /*$disableTargetSelection*/, false, '_addToCollection'), 0);
		$weSuggest->setAdditionalButton(we_html_button::create_button(we_html_button::ADD_COLLECTION, "javascript:we_cmd('edit_new_collection','write_back_to_opener," . $idname . "," . $textname . "','',-1,'" . stripTblPrefix($table) . "');", '', '', $disableTargetSelection, false));

		echo we_html_tools::getHtmlTop('', '', '', we_html_element::jsScript(JS_DIR . 'weAddToCollection.js', '', ['id' => 'loadVarWeAddToCollection', 'data-init' => setDynamicVar([
					'table' => $table,
					'targetInsertIndex' => $insertIndex,
					'targetInsertPosition' => $insertPos,
			])]), we_html_element::body([
				'class' => 'weTreeHeaderAddToCollection'
				], we_html_element::form(['name' => 'we_form', 'method' => 'post', 'onsubmit' => "return false"], we_html_element::hiddens(['we_targetTransaction' => '',
						'we_targetInsertPos' => $insertPos,
						'sel' => '']) .
					we_html_element::div(['style' => "width:452px;"], '
<h1 class="big" style="padding:0;margin:0;">' . g_l('weClass', '[collection][add]') . '</h1>' .
						we_html_element::p(['class' => "small"], we_html_element::span(['class' => 'middlefont', 'style' => "padding-right:5px;padding-bottom:10px;"], g_l('weClass', '[collection][add_help]')) .
							we_html_element::p(['style' => "margin:0 0 10px 0;padding:0;"], $weSuggest->getHTML() . ($hideCheckRecursive ? we_html_element::hidden('InsertRecursive', $presetRecursive) : we_html_forms::checkboxWithHidden($presetRecursive, 'InsertRecursive', g_l('weClass', '[collection][insertRecursive]'))))
						) .
						we_html_element::div([], we_html_button::position_yes_no_cancel(we_html_button::create_button(we_html_button::OK, "javascript:weAddToCollection.press_ok_add('" . $table . "');"), '', we_html_button::create_button('quit_addToCollection', "javascript:we_cmd('exit_addToCollection','','" . $table . "')"), 10, "left")
					))
			))
		);
	}

}
