<?php

/**
 * webEdition CMS
 *
 * $Rev: 15576 $
 * $Author: mokraemer $
 * $Date: 2018-08-16 10:45:45 +0200 (Thu, 16 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_gui_multiEditor{

	/**
	 * Checks if the start-document is a valid document. Content Type text/webedition or text/html
	 * @return bool
	 * @param int $id
	 */
	private static function checkIfValidStartdocument($id, $type = 'document'){

		return ($type === 'object' ?
			(f('SELECT ContentType FROM ' . OBJECT_FILES_TABLE . ' WHERE ID=' . intval($id)) === we_base_ContentTypes::OBJECT_FILE) :
			(f('SELECT ContentType FROM ' . FILE_TABLE . ' WHERE ID=' . intval($id)) === we_base_ContentTypes::WEDOCUMENT));
	}

	public static function start(){
		switch($_SESSION['prefs']['seem_start_type']){
			case 'object':
				if($_SESSION['prefs']['seem_start_file'] > 0 && self::checkIfValidStartdocument($_SESSION['prefs']['seem_start_file'], 'object')){ //	if a stardocument is already selected - show this
					return [
							OBJECT_FILES_TABLE,
							$_SESSION['prefs']['seem_start_file'],
							we_base_ContentTypes::OBJECT_FILE,
					];
				}
				break;
			case '0':
				return ['toggleFrames'];
			case 'document':
				if($_SESSION['prefs']['seem_start_file'] > 0 && self::checkIfValidStartdocument($_SESSION['prefs']['seem_start_file'])){ //	if a stardocument is already selected - show this
					return [
							FILE_TABLE,
							$_SESSION['prefs']['seem_start_file'],
							we_base_ContentTypes::WEDOCUMENT,
					];
				}
				break;
			case 'weapp':
				if($_SESSION['prefs']['seem_start_weapp'] != ''){ //	if a we-app is choosen
					return ['', '', '', 'tool_' . $_SESSION['prefs']['seem_start_weapp'] . '_edit'];
				}
				break;
			default:
			case 'cockpit':
				break;
		}
		//if nothing found, start cockpit
		return ['', '', 'cockpit', 'open_cockpit', '', '', '', '', ''];
	}

}
