<?php

/**
 * webEdition CMS
 *
 * $Rev: 15093 $
 * $Author: mokraemer $
 * $Date: 2018-03-21 12:07:05 +0100 (Wed, 21 Mar 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_gui_tabs{
	private $container = '';

	const WE_ICON_PROPERTIES = 'fa-cog';
	const WE_ICON_CUSTOMER_FILTER = 'fa-group';
	const WE_ICON_WORKSPACE = 'fa-desktop';
	const WE_ICON_EDIT = 'fa-edit';
	const WE_ICON_INFO = 'fa-info-circle';
	const WE_ICON_CONTENT = 'fa-search';
	const WE_ICON_PREVIEW = 'fa-eye';

	public function addTab($text, $icon = '', $isActive = false, $jscmd = '', $attribs = []){
		//$att = $text ? 'title="' . $text . '" ' : '';
		$att = '';
		if(isset($attribs) && is_array($attribs)){
			foreach($attribs as $key => $val){
				$att .= $key . '="' . $val . '" ';
			}
		}
		$this->container .= '<div ' . $att . 'onclick="weTabs.clickHandler(window,this,' . $jscmd . ');" class="' . ($isActive ? 'tabActive' : 'tabNormal') . '"><span class="content">';
		$icons = explode(',', $icon) ?: ['fa-ambulance'];
		foreach($icons as $icon){
			$this->container .= '<i class="icon fa ' . $icon . '"></i>';
		}
		$this->container .= ($text ? '<span class="text">' . $text . '</span>' : '') . '</span></div>';
	}

	function getHTML(){
		return '<div id="tabContainer" name="tabContainer">' . $this->container . '</div>';
	}

}
