<?php

/**
 * webEdition CMS
 *
 * $Rev: 15606 $
 * $Author: mokraemer $
 * $Date: 2018-08-22 11:33:27 +0200 (Wed, 22 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_selector_image extends we_selector_document{

	public function __construct($id, $table = '', $JSIDName = '', $JSTextName = '', $JSCommand = '', $order = '', $we_editDirID = '', $FolderText = '', $rootDirID = 0, $open_doc = false, $multiple = false, $canSelectDir = false, $startID = 0, $lang = ''){
		parent::__construct($id, $table, $JSIDName, $JSTextName, $JSCommand, $order, $we_editDirID, $FolderText, we_base_ContentTypes::IMAGE, $rootDirID, $open_doc, $multiple, $canSelectDir, $startID, '');
	}

	protected function getFrameset(we_base_jsCmd $weCmd, $withPreview = false){
		return '<body class="selector" onload="startFrameset();">' .
			we_html_element::div(['id' => 'fsheader'], $this->printHeaderHTML($weCmd)) .
			we_html_element::iframe('fsbody', $this->getFsQueryString(we_selector_file::BODY), '', '', "top.fsbody.document.body.style.fontSize=top.document.getElementsByName('zoom')[0].value+'%';", true, 'preview') .
			we_html_element::iframe('fspreview', $this->getFsQueryString(we_selector_file::PREVIEW), '', '', '', false) .
			we_html_element::div(['id' => 'fsfooter'], $this->printFooterTable()) .
			we_html_element::div(['id' => 'fspath', 'class' => 'radient']) .
			we_html_element::iframe('fscmd', 'about:blank', '', '', '', false) .
			'</body>';
	}

	protected function printFooterTable($more = null){
		//IE doesn't support slider correctly inside tables, disable this
		return parent::printFooterTable(we_base_browserDetect::inst()->isIE() ? '<input name="zoom" type="hidden"/>' : '<input type="range" style="width:120px;height:20px;" name="zoom" min="50" step="25" max="250" value="100" onchange="top.fsbody.document.body.style.fontSize=this.value+\'%\';"/>');
	}

	protected function getFramsetJSFile(){
		return parent::getFramsetJSFile() . we_html_element::jsScript(JS_DIR . 'selectors/image_selector.js');
	}

	//FIXME: get/set view using tblFile.viewType
	protected function printHeaderTable(we_base_jsCmd $weCmd, $extra = '', $append = true){
		return parent::printHeaderTable($weCmd, '<td id="' . we_search_view::VIEW_ICONS . '" style="display:none">' . we_html_button::create_button(we_html_button::VIEW_ICON, "javascript:setview('" . we_search_view::VIEW_ICONS . "');") . '</td>
		<td id="' . we_search_view::VIEW_LIST . '">' . we_html_button::create_button(we_html_button::VIEW_LIST, "javascript:setview('" . we_search_view::VIEW_LIST . "');") . '</td>', true);
	}

	protected function setFramesetJavaScriptOptions(){
		parent::setFramesetJavaScriptOptions();
		$this->jsoptions['options']['view'] = we_search_view::VIEW_ICONS;
	}

}
