<?php

/**
 * webEdition CMS
 *
 * $Rev: 15650 $
 * $Author: mokraemer $
 * $Date: 2018-08-27 18:57:21 +0200 (Mon, 27 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_tagData_sqlColAttribute extends we_tagData_selectAttribute{
	/**
	 * @var string
	 */
	private $Table;

	/**
	 * @param string $name
	 * @param string $table
	 * @param boolean $required
	 * @param array $filter
	 */
	function __construct($name, $table, $required = false, $filter = [], $module = '', $description = '', $deprecated = false){
		$this->Table = $table;
		$options = [];

		// get options from choosen table
		$tableInfo = $GLOBALS['DB_WE']->metadata($this->Table, we_database_base::META_NAME);
		sort($tableInfo); // #3490

		foreach($tableInfo as $field){
			if(!in_array($field, $filter)){
				$options[] = new we_tagData_option($field);
			}
		}
		parent::__construct($name, $options, $required, $module, $description, $deprecated);
	}

}

//FIXME: remove
class weTagData_sqlColAttribute extends we_tagData_sqlColAttribute{

	public function __construct($name, $table, $required = false, $filter = array(), $module = '', $description = '', $deprecated = false){
		t_e('deprecated', 'this class is removed in 8.1');
		parent::__construct($name, $table, $required, $filter, $module, $description, $deprecated);
	}

}
