<?php
/**
 * webEdition CMS
 *
 * $Rev: 15660 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 11:41:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * General Definition of WebEdition Voting
 *
 */
class we_voting_list extends we_listview_base{//FIXME this should be an instance of we_listview_base
	//properties
	var $Version;

	/**
	 * Default Constructor
	 * Can load or create new Newsletter depends of parameter
	 */
	public function __construct($name, $groupid, $version, $rows, $offset, $desc, $order, $subgroup, $start){
		parent::__construct($name, $rows, $offset, $order, $desc);
		$this->Version = $version;
		$this->start = $start;
		if($this->start == 0){
			$this->start += $offset;
		}

		$childs_query = '';
		if($groupid != 0){
			$childs_query = '(ParentID=' . intval($groupid);
			if($subgroup){
				$childs = [];
				we_readChilds($groupid, $childs, VOTING_TABLE, true, '', 'IsFolder', 1);
				$childs_query .= ' OR ParentID=' . implode(' OR ParentID=', $childs);
			}
			$childs_query .= ')';
		}

		$limit = ($rows || $this->start ?
			' LIMIT ' . $this->start . ',' . ($rows == 0 ? 9999999 : $rows) : '');

		if($order != ''){
			$order_sql = ' ORDER BY ' . $order;
			if($desc){
				$order_sql .= ' DESC ';
			} else {
				$order_sql .= ' ASC ';
			}
		}

		$this->anz_all = f('SELECT COUNT(1) FROM ' . VOTING_TABLE . ' WHERE IsFolder=0 ' . (!empty($childs_query) ? ' AND ' . $childs_query : '') . $order_sql, '', $this->DB_WE);

		$this->DB_WE->query('SELECT ID FROM ' . VOTING_TABLE . ' WHERE IsFolder=0 ' . (!empty($childs_query) ? ' AND ' . $childs_query : '') . $order_sql . $limit);
	}

	public function next_record(){
		if($this->DB_WE->next_record(MYSQLI_ASSOC)){
			we_tag_voting::$currentVoting = new we_voting_voting($this->DB_WE->f('ID'));
			we_tag_voting::$currentVoting->setDefVersion($this->Version);
			return true;
		}
		return false;
	}

	public function getNextLink($attribs, $content = ''){
		if(!$this->hasNextPage()){
			return $content;
		}

		$urlID = we_weTag_tag::getAttribute('id', $attribs, 0, we_base_request::INT);
		$foo = $this->start + $this->rows;
		$attribs['href'] = we_tag('url', ['id' => ($urlID ?: 'self'), 'hidedirindex' => false]) . '?' . oldHtmlspecialchars(we_listview_base::we_makeQueryString(['_we_vl_start_' . $this->name => $foo]));
		$attribs['rel'] = 'next';

		return getHtmlTag('a', $attribs, $content, true);
	}

	public function hasNextPage($parentStart = false){
		return (($this->start + $this->rows) < $this->anz_all);
	}

	public function getBackLink($attribs, $content = ''){
		if($this->hasPrevPage()){
			$urlID = we_weTag_tag::getAttribute('id', $attribs, 0, we_base_request::INT);
			$foo = $this->start - $this->rows;
			$attribs['href'] = we_tag('url', ['id' => ($urlID ?: 'self'), 'hidedirindex' => false]) . '?' . oldHtmlspecialchars(we_listview_base::we_makeQueryString(['_we_vl_start_' . $this->name => $foo]));
			$attribs['rel'] = 'prev';

			return getHtmlTag('a', $attribs, $content, true);
		}
		return $content;
	}

	function hasPrevPage($parentStart = false){
		return (abs($this->start) != abs($this->offset));
	}

}
