<?php

/**
 * webEdition CMS
 *
 * $Rev: 15656 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 01:19:43 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_addPercent extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		$attribs['_type'] = 'stop';
		return '<?php ' . we_weTag_parser::printTag('addPercent', ['_type' => 'start']) . ';?>' . $content . '<?= ' . we_weTag_parser::printTag('addPercent', $attribs) . ';?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		//internal Attribute
		switch(self::getAttribute('_type', $attribs, '', we_base_request::STRING)){
			case 'start':
				$GLOBALS['we']['calculate'] = 1;
				ob_start();
				return '';
			case 'stop':
				$content = we_base_util::std_numberformat(ob_get_clean());
				unset($GLOBALS['we']['calculate']);
				if(($foo = self::attributeMissing($attribs, 'percent', __CLASS__))){
					return $foo;
				}
				$percent = self::getAttribute('percent', $attribs, 0, we_base_request::FLOAT);
				$num_format = self::getAttribute('num_format', $attribs, '', we_base_request::STRING);
				$result = ($content / 100) * (100 + $percent);
				return ($num_format ? //bug 6437 gibt immer deutsch zurück (das ist der default von formatnaumber), was das verhalten ändert
					we_base_util::formatNumber($result, $num_format) :
					$result);
			default:
				return self::attributeMissing($attribs, '_type', __CLASS__);
		}
	}

}

function we_tag_addPercent(array $attribs){
	return we_tag_addPercent::tag($attribs);
}
