<?php

/**
 * webEdition CMS
 *
 * $Rev: 15656 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 01:19:43 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_calculate extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		$attribs['_type'] = 'stop';
		$content = strtr($content, ['<?=' => '', ';?>' => '', '; ?>' => '', '<?php' => '', 'echo' => '', ';' => '']);
		return '<?php ' . we_weTag_parser::printTag('calculate', ['_type' => 'start']) . '; echo ' . $content . ';echo ' . we_weTag_parser::printTag('calculate', $attribs) . ';?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		//internal Attribute
		switch(self::getAttribute('_type', $attribs, '', we_base_request::STRING)){
			case 'start':
				$GLOBALS['we']['calculate'] = 1;
				ob_start();
				return '';
			case 'stop':
				$content = ob_get_clean();
				unset($GLOBALS['we']['calculate']);
				$sum = self::getAttribute('sum', $attribs, '', we_base_request::STRING);
				$num_format = self::getAttribute('num_format', $attribs, '', we_base_request::STRING);
				$print = self::getAttribute('print', $attribs, true, we_base_request::BOOL);
				$result = (trim($content) ? $content : 0);

				if($sum){
					we_tag_sum::addSum($sum, $result);
				}
				return ($print ? ($num_format ? we_base_util::formatNumber($result, $num_format, intval(self::getAttribute('decimals', $attribs, 2, we_base_request::INT))) : $result) : '');
			default:
				return self::attributeMissing($attribs, '_type', __CLASS__);
		}
	}

}

function we_tag_calculate(array $attribs){
	return we_tag_calculate::tag($attribs);
}
