<?php

/**
 * webEdition CMS
 *
 * $Rev: 15664 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:56:44 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_css extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(($foo = self::attributeMissing($attribs, 'id', __CLASS__))){
			return $foo;
		}

		$src = f('SELECT CONCAT(Path,"?m=",Published) FROM ' . FILE_TABLE . ' WHERE Published>0 AND ID=' . self::getAttribute('id', $attribs, 0, we_base_request::INT));
		if(!$src){
			return '';
		}

		$nolink = false;
		switch(self::getAttribute('applyto', $attribs, defined('CSSAPPLYTO_DEFAULT') ? CSSAPPLYTO_DEFAULT : 'around', we_base_request::STRING)){
			case 'around' :
				break;
			case 'wysiwyg' :
				$nolink = true;
			case 'all' :
				switch(self::getAttribute('media', $attribs, '', we_base_request::STRING)){
					case '':
					case 'screen':
					case 'all':
						// we still need addDocumentCss() because JS getDocumentCss() won't apply it when applyTo=wysiwyg!
						$GLOBALS['we_doc']->addDocumentCss($src);
						break;
				}
				break;
		}
		//	remove not needed elements
		$attribs = removeAttribs($attribs, ['id', 'applyto']);
		$rel = self::getAttribute('rel', $attribs, 'stylesheet', we_base_request::STRING);
		if($rel === 'preload'){
			$attribs['as'] = 'style';
			header('Link: <' . $src . '>; rel=preload; as=style', false);
		}
		$attribs['rel'] = $rel;
		$attribs['type'] = 'text/css';
		$attribs['href'] = $src;

		if($GLOBALS['we']['editmode']){
			// these stylesheets are applied to wysiwyg using addDocumentCss depending on attribute "applyto":
			// so prevent JS getDocumentCss() from applying it again or when applyto=around!
			$attribs['href'] .= '&wysiwyg=0';
		}

		return $nolink ? '' : getHtmlTag('link', $attribs) . "\n";
	}

}

function we_tag_css(array $attribs){
	return we_tag_css::tag($attribs);
}
