<?php

/**
 * webEdition CMS
 *
 * $Rev: 15663 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:01:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifCat extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$categories = self::getAttribute('categories', $attribs, self::getAttribute('category', $attribs, [], we_base_request::STRING_LIST, true), we_base_request::STRING_LIST);
		$catids = self::getAttribute('categoryids', $attribs, [], we_base_request::INTLISTA);
		if(!$categories && !$catids){
			if(($foo = self::attributeMissing($attribs, 'categories', __CLASS__))){
				echo $foo;
				return false;
			}
		}

		$parent = self::getAttribute('parent', $attribs, false, we_base_request::BOOL);
		$docAttr = self::getAttribute('doc', $attribs, 'self', we_base_request::STRING);

		switch($docAttr){
			case 'listview':
				$cat = (empty(we_tag_listview::$current) ? '' : we_tag_listview::$current->f(we_listview_base::CATEGORY_FIELD));
				break;
			default:
				$doc = self::getDocForTag($docAttr);
				$cat = $doc->Category;
		}

		if($catids){
			if($parent){
				$categories = id_to_path($catids, CATEGORY_TABLE, $GLOBALS['DB_WE'], true);
			} else {
				//no need to query db
				$cat = array_filter(array_map('intval', explode(',', $cat)));
				return (array_intersect($cat, array_filter($catids)) ? true : false);
			}
		}

		$DocCatsPaths = id_to_path($cat, CATEGORY_TABLE, $GLOBALS['DB_WE'], true);
		$DocCatsPathsStr = implode(',', $DocCatsPaths);

		foreach($categories as $match){
			$match = '/' . trim($match, '/');
			if(in_array($match, $DocCatsPaths)){
				return true;
			}
			if($parent && strpos($DocCatsPathsStr, $match . '/') !== false){
				return true;
			}
		}
		return false;
	}

}

function we_tag_ifCat(array $attribs){
	return we_tag_ifCat::tag($attribs);
}
