<?php

/**
 * webEdition CMS
 *
 * $Rev: 15663 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:01:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifDoctype extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(($foo = self::attributeMissing($attribs, 'doctypes', __CLASS__))){
			echo $foo;
			return false;
		}
		$matchArr = self::getAttribute('doctypes', $attribs, [], we_base_request::STRING_LIST);

		$docAttr = self::getAttribute('doc', $attribs, 'self', we_base_request::STRING);

		switch($docAttr){
			case 'listview':
				$doctype = (we_tag_listview::$current ? we_tag_listview::$current->f(we_listview_base::DOCTYPE_FIELD) : false);
				break;
			default:
				$doc = self::getDocForTag($docAttr);
				$doctype = ($doc instanceof we_webEditionDocument) ? $doc->DocType : false;
		}

		if(isset($doctype) && $doctype !== false){
			foreach($matchArr as $match){
				if($doctype == f('SELECT ID FROM ' . DOC_TYPES_TABLE . ' WHERE DocType="' . $GLOBALS['DB_WE']->escape($match) . '"')){
					return true;
				}
			}
		}
		return false;
	}

}

function we_tag_ifDoctype(array $attribs){
	return we_tag_ifDoctype::tag($attribs);
}
