<?php

/**
 * webEdition CMS
 *
 * $Rev: 15663 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:01:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifRegisteredUserCanChange extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$admin = self::getAttribute('admin', $attribs, '', we_base_request::STRING);
		$userid = self::getAttribute('userid', $attribs, '', we_base_request::STRING); // deprecated  use protected=true instead
		$protected = self::getAttribute('protected', $attribs, false, we_base_request::BOOL);
		if(!(isset($_SESSION['webuser']) && isset($_SESSION['webuser']['ID']) && !empty($_SESSION['webuser']['registered']))){
			return false;
		}
		if($admin && (!empty($_SESSION['webuser'][$admin]))){
			return true;
		}

		if(we_tag_listview::$current){
			return ($protected ? we_tag_listview::$current->f(we_listview_base::CUSTOMER_FIELD) : we_tag_listview::$current->f($userid)) == $_SESSION['webuser']['ID'];
		}
		return ($protected ? $GLOBALS['we_doc']->WebUserID : $GLOBALS['we_doc']->getElement($userid)) == $_SESSION['webuser']['ID'];
	}

}

function we_tag_ifRegisteredUserCanChange(array $attribs){
	return we_tag_ifRegisteredUserCanChange::tag($attribs);
}
