<?php

/**
 * webEdition CMS
 *
 * $Rev: 15664 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:56:44 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifUser extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(empty($GLOBALS['we']['editmode']) || empty($_SESSION['user'])){
			//if not editmode or in frontend, show content
			return !self::getAttribute('not', $attribs, false, we_base_request::BOOL);
		}

		if(self::getAttribute('admin', $attribs, false, we_base_request::BOOL) && we_base_permission::hasPerm('ADMINISTRATOR')){
			return true;
		}
		$user = self::getAttribute('user', $attribs, [], we_base_request::INTLISTA);
		$group = self::getAttribute('group', $attribs, [], we_base_request::INTLISTA);
		$recurse = self::getAttribute('recursive', $attribs, false, we_base_request::BOOL);

		$ret = ($user ? in_array($_SESSION['user']['ID'], $user) : false);

		if($group){
			if($recurse && empty($_SESSION['user']['Groups'])){
				self::getUserGroups($_SESSION['user']['Group']);
				$_SESSION['user']['Groups'] = [];
				foreach($_SESSION['user']['Aliases'] as $parent){
					self::getUserGroups($parent);
				}
			}
			$ret |= ($recurse ? !empty(array_intersect($group, $_SESSION['user']['Groups'])) : in_array($_SESSION['user']['Group'], $group));
		}

		return $ret;
	}

	private static function getUserGroups($parent){
		while($parent){
			$_SESSION['user']['Groups'][] = $parent;
			$parent = f('SELECT ParentID FROM ' . USER_TABLE . ' WHERE ID=' . $parent);
		}
	}

}

function we_tag_ifUser($attribs = []){
	return we_tag_ifUser::tag($attribs);
}
