<?php

/**
 * webEdition CMS
 *
 * $Rev: 15664 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:56:44 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifWritten extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$type = (self::getAttribute('type', $attribs, '', we_base_request::STRING) ?: self::getAttribute('var', $attribs, 'document', we_base_request::STRING)) ?: self::getAttribute('doc', $attribs, 'document', we_base_request::STRING);
		switch($type){
			case 'customer':
				return we_tag_saveRegisteredUser::$status === we_customer_customer::PWD_ALL_OK;
			case 'shop':
				return we_tag_writeShopData::$status === true;
			default:
				$name = self::getAttribute('formname', $attribs, (we_tag_form::$name ?: we_base_constants::DEFAULT_FORM), we_base_request::STRING);
				//we need isset if we:write was not called before
				return isset(we_tag_write::$status[$type][$name]) && empty(we_tag_write::$status[$type][$name]);
		}
	}

}

function we_tag_ifWritten(array $attribs){
	return we_tag_ifWritten::tag($attribs);
}
