<?php

/**
 * webEdition CMS
 *
 * $Rev: 15644 $
 * $Author: mokraemer $
 * $Date: 2018-08-26 13:48:35 +0200 (Sun, 26 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_linkToSeeMode extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$id = self::getAttribute('id', $attribs, 0, we_base_request::INT); //	if a document-id is selected go to that document
		$oid = self::getAttribute('oid', $attribs, 0, we_base_request::INT); //	if an object-id is selected go to that object
		$permission = self::getAttribute('permission', $attribs, '', we_base_request::STRING);
		$docAttr = self::getAttribute('doc', $attribs, "top", we_base_request::STRING);
		$xml = self::getAttribute('xml', $attribs, XHTML_DEFAULT, we_base_request::BOOL);

		return ''; //this feature is currently unsupported
		// check for value attribute
		if(($foo = self::attributeMissing($attribs, "value", __CLASS__))){
			return $foo;
		}

		$value = self::getAttribute('value', $attribs, '', we_base_request::STRING);

		if(!empty($id)){
			$type = 'document';
		} elseif(isset($GLOBALS['we_obj']) || $oid){ // use object if possible
			$type = 'object';
			if($oid){
				$id = $oid;
			} elseif(isset($GLOBALS['we_obj'])){
				$id = $GLOBALS['we_obj']->ID;
			}
		} else {
			$type = 'document';
			$doc = self::getDocForTag($docAttr, true); // check if we should use the top document or the  included document
			$id = $doc->ID;
		}

		if(!empty($_SESSION['webuser']) && $_SESSION['webuser']['registered'] && !isset($_REQUEST['we_transaction'])){
			if(!$permission || !empty($_SESSION['webuser'][$permission])){ // Has webUser the right permissions??
				//	check if the customer is a user, too.
				$tmpDB = $GLOBALS['DB_WE'];

				$q = f('SELECT passwd FROM ' . USER_TABLE . ' WHERE IsFolder=0 AND LoginDenied=0 AND username="' . $tmpDB->escape($_SESSION['webuser']['Username']) . '"', '', $tmpDB);

				if($q && we_users_user::comparePasswords($_SESSION['webuser']['Username'], $q, $_SESSION['webuser']['Password'])){// customer is also a user
					unset($q);
					$retStr = getHtmlTag(
							'form', ['method' => 'post',
							'name' => 'startSeeMode_' . $type . '_' . $id,
							'target' => '_parent',
							'action' => WEBEDITION_DIR . 'loginToSuperEasyEditMode.php'
							], getHtmlTag('input', ['type' => 'hidden', 'name' => 'username', 'value' => $_SESSION['webuser']['Username'], 'xml' => $xml]) .
							getHtmlTag('input', ['type' => 'hidden', 'name' => 'type', 'value' => $type, 'xml' => $xml]) .
							getHtmlTag('input', ['type' => 'hidden', 'name' => 'id', 'value' => $id, 'xml' => $xml]) .
							getHtmlTag('input', ['type' => 'hidden', 'name' => 'path', 'value' => getScriptName(true), 'xml' => $xml])
						) .
						getHtmlTag('a', ['href' => "javascript:document.forms['startSeeMode_" . $type . '_' . $id . "'].submit();",
							'xml' => $xml
							], $value);
				} else { //	customer is no user
					return '<!-- ERROR: CUSTOMER IS NO USER! -->';
				}
				unset($tmpDB);
			} else { // User has not the right permissions.
				return '<!-- ERROR: USER DOES NOT HAVE REQUIRED PERMISSION! -->';
			}
		} else { //	webUser is not registered, show nothing
			return '<!-- ERROR: USER HAS NOT BEEN LOGGED IN! -->';
		}
		return $retStr;
	}

}

function we_tag_linkToSeeMode(array $attribs){
	return we_tag_linkToSeeMode::tag($attribs);
}
