<?php

/**
 * webEdition CMS
 *
 * $Rev: 15713 $
 * $Author: mokraemer $
 * $Date: 2018-09-05 14:54:44 +0200 (Wed, 05 Sep 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_newsletterSwitch extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(!$GLOBALS['we']['editmode']){
			return '';
		}
//html=false, text=true

		if(($val = we_base_request::_(we_base_request::BOOL, 'we_set_newsletterFormat', -1)) !== -1 && $GLOBALS['we_doc']->InWebEdition){
			$GLOBALS['we_doc']->setEditorPersistent('newsletterFormat', $val);
		}

		$val = (bool) $GLOBALS['we_doc']->getEditorPersistent('newsletterFormat');


		return '
<table class="we weEditTable we_switcher">
	<tr><td><b>' . g_l('modules_newsletter', '[newsletter][preview]') . '</b></td>
	<td><input id="set_newsletterHtml" type="radio" name="we_set_newsletterFormat" value="0" onclick="top.we_cmd(\'reload_editpage\');"' . (!$val ? ' checked' : '') . ' /><label for="set_newsletterHtml">HTML&nbsp;' . g_l('modules_newsletter', '[email]') . '</label></td>
	<td><input id="set_newsletterText" type="radio" name="we_set_newsletterFormat" value="1" onclick="top.we_cmd(\'reload_editpage\');"' . ($val ? ' checked' : '') . ' /><label for="set_newsletterText">' . g_l('modules_newsletter', '[type_text]') . ' ' . g_l('modules_newsletter', '[email]') . '</label></td>
	</tr>
</table>';
	}

}

function we_tag_newsletterSwitch(){
	return we_tag_newsletterSwitch::tag();
}
