<?php

/**
 * webEdition CMS
 *
 * $Rev: 15663 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:01:53 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_objectLanguage extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$type = self::getAttribute("type", $attribs, "complete", we_base_request::STRING);
		$case = self::getAttribute("case", $attribs, "unchanged", we_base_request::STRING);

		$lang = (we_tag_listview::$current && we_tag_listview::$current instanceof we_listview_base ? we_tag_listview::$current->f(we_listview_base::LANG_FIELD) : '');

		switch($type){
			case 'language':
				$out = substr($lang, 0, 2);
				break;
			case 'country':
				$out = substr($lang, 3, 2);
				break;
			default:
				$out = $lang;
		}
		switch($case){
			case 'uppercase':
				return strtoupper($out);
			case 'lowercase':
				return strtolower($out);
			default:
				return $out;
		}
	}

}

function we_tag_objectLanguage(array $attribs){
	return we_tag_objectLanguage::tag($attribs);
}
