<?php

/**
 * webEdition CMS
 *
 * $Rev: 15644 $
 * $Author: mokraemer $
 * $Date: 2018-08-26 13:48:35 +0200 (Sun, 26 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_repeatShopItem extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		if(($foo = self::attributeMissing($attribs, 'shopname', __CLASS__))){
			return $foo;
		}

		$attribs['_type'] = 'start';
		return '<?php ' . we_weTag_parser::printTag('repeatShopItem', $attribs) . '; while($GLOBALS[\'lv\']->next_record()) {?>' . $content . '<?php } ' . we_weTag_parser::printTag('repeatShopItem', [
				'_type' => 'stop']) . ';?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(!we_modules_info::isActive(we_modules_info::SHOP)){
			echo self::modulMissingError('Shop', __CLASS__);
			return;
		}
		$shopname = self::getAttribute('shopname', $attribs, '', we_base_request::STRING);

		//internal Attribute
		$intType = self::getAttribute('_type', $attribs, '', we_base_request::STRING);
		switch($intType){
			case 'start':
				if(($foo = self::attributeMissing($attribs, 'shopname', __CLASS__))){
					echo $foo;
					return;
				}
				we_modules_info::isActive(we_modules_info::SHOP);

				$_SESSION['we_shopname'] = $shopname;

				if(!isset($GLOBALS[$shopname]) || empty($GLOBALS[$shopname])){
					echo self::parseError(sprintf(g_l('parser', '[missing_createShop]'), 'repeatShopItem'), __CLASS__);
				}
				$lv = new we_listview_shopItems($GLOBALS[$shopname]);
				self::pre_listview($lv);
				break;
			case 'stop':
				self::post_listview();
				break;
		}
	}

}

function we_tag_repeatShopItem(array $attribs){
	return we_tag_repeatShopItem::tag($attribs);
}
