<?php

/**
 * webEdition CMS
 *
 * $Rev: 15664 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 20:56:44 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_search extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$name = self::getAttribute('name', $attribs, 0, we_base_request::STRING);
		$xml = self::getAttribute('xml', $attribs, XHTML_DEFAULT, we_base_request::BOOL);
		$value = self::getAttribute('value', $attribs, '', we_base_request::STRING);

		$searchValue = str_replace(['"', '\\"',], '', trim(we_base_request::_(we_base_request::STRING, 'we_lv_search_' . $name, $value)));
		$attsHidden = ['type' => 'hidden',
			'xml' => $xml,
			'name' => 'we_from_search_' . $name,
			'value' => (!empty($GLOBALS['we']['editmode']) ? 0 : 1)
		];


		switch(self::getAttribute('type', $attribs, '', we_base_request::STRING)){
			case 'print':
				return $searchValue;
			case 'textinput':
				$atts = array_merge(
					removeAttribs($attribs, ['type', 'onchange', 'name', 'cols', 'rows'
					]), ['name' => 'we_lv_search_' . $name,
					'type' => 'text',
					'value' => $searchValue,
					'xml' => $xml
				]);
				return getHtmlTag('input', $atts) . getHtmlTag('input', $attsHidden);

			case 'textarea':
				$atts = array_merge(
					removeAttribs(
						$attribs, ['type', 'onchange', 'name', 'size', 'maxlength', 'value'
					]), ['class' => 'defaultfont',
					'name' => 'we_lv_search_' . $name,
					'xml' => $xml
				]);

				return getHtmlTag('textarea', $atts, $searchValue, true) . getHtmlTag('input', $attsHidden);
		}
		return '';
	}

}

function we_tag_search(array $attribs){
	return we_tag_search::tag($attribs);
}
