<?php

/**
 * webEdition CMS
 *
 * $Rev: 15714 $
 * $Author: mokraemer $
 * $Date: 2018-09-05 15:22:25 +0200 (Wed, 05 Sep 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_select extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		return '<?php if($GLOBALS[\'we\'][\'editmode\']){ ob_start();?>' . $content . '<?php $we_select_content=ob_get_clean();}else{$we_select_content=\'\';}'
			. 'echo ' . we_weTag_parser::printTag('select', $attribs, '$we_select_content', false, true) . ';?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(($foo = self::attributeMissing($attribs, 'name', __CLASS__))){
			return $foo;
		}
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$multiple = self::getAttribute('multiple', $attribs, false, we_base_request::BOOL);
		$val = $GLOBALS['we_doc']->getElement($name);
		if(!$GLOBALS['we']['editmode']){
			return $val;
		}
		$val = $val ? explode(',', $val) : [];

		$onchange = self::getAttribute('onchange', $attribs, '', we_base_request::JS);
		$reload = self::getAttribute('reload', $attribs, false, we_base_request::BOOL);
		switch(self::getAttribute('type', $attribs, 'html', we_base_request::STRING)){
			case 'csv':
				$vals = self::getAttribute('values', $attribs, array_filter(explode(',', $content)), we_base_request::STRING_LIST);
				$content = '';
				foreach($vals as $cur){
					$content .= (in_array($cur, $val, true) ?
						getHtmlTag('option', ['value' => $cur, 'selected' => 'selected'], $cur, true) :
						getHtmlTag('option', ['value' => $cur], $cur, true)
						);
				}
				break;
			case 'html':
			default:
				$content = preg_replace('|<(option[^>]*) selected( *=? *"selected")?([^>]*)>|i', '<${1}${3}>', $content);
				if(stripos($content, '<option>') !== false){
					foreach($val as $v){
						$content = preg_replace('|<option>' . preg_quote($v) . '( ?[<\n\r\t])|i', '<option selected="selected">' . $v . '${1}', $content);
					}
				}
				if(preg_match('|<option[^>]*value=[\'"]?.*[\'"]?>|i', $content)){
					foreach($val as $v){
						$content = preg_replace('|<option([^>]*)value *= *"' . preg_quote($v) . '"([^>]*)>|i', '<option value="' . $v . '" selected="selected">', $content);
					}
				}
				break;
		}
		$attribs = removeAttribs($attribs, ['reload', 'value', '_name_orig', 'type', 'values', 'multiple']); //	not html - valid
		if($multiple){
			$attribs['multiple'] = 'multiple';
		}
		$attribs['class'] = 'defaultfont';
		$attribs['name'] = 'we_' . $GLOBALS['we_doc']->Name . '_select[' . $name . ($multiple ? '#multiple][]' : ']');
		$attribs['onchange'] = '_EditorFrame.setEditorIsHot(true);' . ($onchange ?: '') . ';' . ($reload ? (';setScrollTo();top.we_cmd(\'reload_editpage\');') : '');
		return we_html_element::span(['class' => 'we we_select'], getHtmlTag('select', $attribs, $content, true));
	}

}

function we_tag_select(array $attribs, $content){
	return we_tag_select::tag($attribs, $content);
}
