<?php
/**
 * webEdition CMS
 *
 * $Rev: 15655 $
 * $Author: mokraemer $
 * $Date: 2018-08-28 01:01:01 +0200 (Tue, 28 Aug 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * @return string
 * @param array $attribs
 * @param string $content
 */
abstract class we_tag_xmlfeed extends we_weTag_tag{
	public static $xmlfeeds = [];

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(($foo = self::attributeMissing($attribs, ['name' => false, 'url' => false], __CLASS__))){
			return $foo;
		}

		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$url = self::getAttribute('url', $attribs, '', we_base_request::URL);
		$refresh = abs(self::getAttribute('refresh', $attribs, 30, we_base_request::INT)) * 60;
		$timeout = abs(self::getAttribute('timeout', $attribs, 0, we_base_request::INT));

		self::$xmlfeeds[$name] = new we_xml_browser();
		$cache = WE_CACHE_PATH . 'xmlfeed_' . md5($url);

		$do_refresh = ($refresh > 0 ? (!is_file($cache) || ((filemtime($cache) + $refresh) < time())) : true);

		if($do_refresh){
			$ret = self::$xmlfeeds[$name]->getFile($url, $timeout);
			if($ret){
				self::$xmlfeeds[$name]->saveCache($cache, (2 * $refresh)); //keep file longer, in case of timeouts
			} else if($timeout && is_file($cache)){
				//timeout + last file exists
				self::$xmlfeeds[$name]->loadCache($cache);
			}
		} else {
			self::$xmlfeeds[$name]->loadCache($cache);
		}
		return '';
	}

}

function we_tag_xmlfeed(array $attribs){
	return we_tag_xmlfeed::tag($attribs);
}
