<?php
/**
 * webEdition CMS
 *
 * $Rev: 15450 $
 * $Author: mokraemer $
 * $Date: 2018-07-02 12:04:50 +0200 (Mon, 02 Jul 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
we_html_tools::protect();
$jsCmd = new we_base_jsCmd();

switch(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1)){
	case 'saveService':
		$service = new we_validation_service(we_base_request::_(we_base_request::INT, 'id'), 'custom', we_base_request::_(we_base_request::STRING, 'category'), we_base_request::_(we_base_request::STRING, 'name'), we_base_request::_(we_base_request::STRING, 'host'), we_base_request::_(we_base_request::FILE, 'path'), we_base_request::_(we_base_request::STRING, 's_method'), we_base_request::_(we_base_request::STRING, 'varname'), we_base_request::_(we_base_request::STRING, 'checkvia'), we_base_request::_(we_base_request::STRING, 'ctype'), we_base_request::_(we_base_request::STRING, 'additionalVars'), we_base_request::_(we_base_request::STRING, 'fileEndings'), we_base_request::_(we_base_request::BOOL, 'active'));
		if(($selectedService = we_validation_base::saveService($service))){
			$jsCmd->addMsg(g_l('validation', '[edit_service][saved_success]'), we_base_util::WE_MESSAGE_NOTICE);
		} else {
			$selectedService = $service;
			$jsCmd->addMsg(g_l('validation', '[edit_service][saved_failure]') . (isset($GLOBALS['errorMessage']) ? '\n' . $GLOBALS['errorMessage'] : ''), we_base_util::WE_MESSAGE_ERROR);
		}
		break;
	case 'deleteService':
		$service = new we_validation_service(we_base_request::_(we_base_request::INT, 'id'), 'custom', we_base_request::_(we_base_request::STRING, 'category'), we_base_request::_(we_base_request::STRING, 'name'), we_base_request::_(we_base_request::STRING, 'host'), we_base_request::_(we_base_request::FILE, 'path'), we_base_request::_(we_base_request::STRING, 's_method'), we_base_request::_(we_base_request::STRING, 'varname'), we_base_request::_(we_base_request::STRING, 'checkvia'), we_base_request::_(we_base_request::STRING, 'ctype'), we_base_request::_(we_base_request::STRING, 'additionalVars'), we_base_request::_(we_base_request::STRING, 'fileEndings'), we_base_request::_(we_base_request::BOOL, 'active'));
		if(we_validation_base::deleteService($service)){
			$jsCmd->addMsg(g_l('validation', '[edit_service][delete_success]'), we_base_util::WE_MESSAGE_NOTICE);
		} else {
			$jsCmd->addMsg(g_l('validation', '[edit_service][delete_failure]'), we_base_util::WE_MESSAGE_ERR);
		}
		break;
	case 'selectService';
		$selectedName = we_base_request::_(we_base_request::STRING, 'validationService');
		break;
	case 'newService':
		$selectedService = new we_validation_service(0, 'custom', 'accessible', g_l('validation', '[edit_service][new]'), 'www.example', '/path', 'get', 'varname', 'url', 'text/html', '', '.html', 1);
		break;
}

//  get all custom services from the database - new service select it
$services = we_validation_base::getValidationServices('edit');
if(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1) === 'newService' && $selectedService){
	$services[] = $selectedService;
}

if($services){
	foreach($services as $service){

		$selectArr[$service->getName()] = htmlentities($service->name);

		if(!isset($selectedService)){
			$selectedService = $service;
		}

		if(isset($selectedName) && $service->getName() == $selectedName){
			$selectedService = $service;
		}
	}
	$hiddenFields = we_html_element::hiddens(['id' => $selectedService->id,
			'art' => 'custom'
	]);
} else {
	$hiddenFields = we_html_element::hidden('art', 'custom');
	$selectArr = [];
}


//  table with new and delete
$table = '<table>
    <tr><td style="padding-right:10px;">' . we_html_tools::select('validationService', $selectArr, 5, (isset($selectedService) ? $selectedService->getName() : ''), false, [
		'onchange' => 'we_cmd(\'customValidationService\',\'selectService\');'], true, 320) . '</td>
        <td style="vertical-align:top">' . we_html_button::create_button('new_service', "javascript:we_cmd('customValidationService','newService');")
	. '<div style="height:10px;"></div>'
	. we_html_button::create_button(we_html_button::DELETE, "javascript:we_cmd('customValidationService','deleteService');", '', '', (empty($services))) . '
        </td>
    </tr>
    </table>' .
	$hiddenFields;

if($services){
	$parts = [
		['headline' => g_l('validation', '[available_services]'),
			'html' => $table,
			'space' => we_html_multiIconBox::SPACE_MED2],
		['headline' => g_l('validation', '[category]'),
			'html' => we_html_tools::select('category', we_validation_base::getAllCategories(), 1, $selectedService->category),
			'space' => we_html_multiIconBox::SPACE_MED2,
			'noline' => true],
		['headline' => g_l('validation', '[service_name]'),
			'html' => we_html_tools::textInput('name', $selectedService->name),
			'space' => we_html_multiIconBox::SPACE_MED2,
			'noline' => true],
		['headline' => g_l('validation', '[host]'),
			'html' => we_html_tools::textInput('host', $selectedService->host),
			'space' => we_html_multiIconBox::SPACE_MED2,
			'noline' => true],
		['headline' => g_l('validation', '[path]'),
			'html' => we_html_tools::textInput('path', $selectedService->path),
			'space' => we_html_multiIconBox::SPACE_MED2,
			'noline' => true],
		['headline' => g_l('validation', '[ctype]'),
			'html' => we_html_tools::textInput('ctype', $selectedService->ctype) . '<br/><span class="small">' . g_l('validation', '[desc][ctype]') . '</span>',
			'space' => we_html_multiIconBox::SPACE_MED2,
			'noline' => true],
		['headline' => g_l('validation', '[fileEndings]'),
			'html' => we_html_tools::textInput('fileEndings', $selectedService->fileEndings) . '<br/><span class="small">' . g_l('validation', '[desc][fileEndings]') . '</span>',
			'space' => we_html_multiIconBox::SPACE_MED2,
			'noline' => true],
		['headline' => g_l('validation', '[method]'),
			'html' => we_html_tools::select('s_method', ['post' => 'post', 'get' => 'get'], 1, $selectedService->method, false),
			'space' => we_html_multiIconBox::SPACE_MED2,
			'noline' => true],
		['headline' => g_l('validation', '[checkvia]'),
			'html' => we_html_tools::select('checkvia', ['url' => g_l('validation', '[checkvia_url]'), 'fileupload' => g_l('validation', '[checkvia_upload]')], 1, $selectedService->checkvia, false),
			'space' => we_html_multiIconBox::SPACE_MED2,
			'noline' => true],
		['headline' => g_l('validation', '[varname]'),
			'html' => we_html_tools::textInput('varname', $selectedService->varname) . '<br/><span class="small">' . g_l('validation', '[desc][varname]') . '</span>',
			'space' => we_html_multiIconBox::SPACE_MED2,
			'noline' => true],
		['headline' => g_l('validation', '[additionalVars]'),
			'html' => we_html_tools::textInput('additionalVars', $selectedService->additionalVars) . '<br/><span class="small">' . g_l('validation', '[desc][additionalVars]') . '</span>',
			'space' => we_html_multiIconBox::SPACE_MED2],
		['headline' => g_l('validation', '[active]'),
			'html' => we_html_tools::select('active', [0 => 'false', 1 => 'true'], 1, $selectedService->active) . '<br/><span class="small">' . g_l('validation', '[desc][active]') . '</span>',
			'space' => we_html_multiIconBox::SPACE_MED2]
	];
} else {
	$parts = [
		['headline' => g_l('validation', '[available_services]'), 'html' => $table, 'space' => we_html_multiIconBox::SPACE_MED2]
	];
}

echo we_html_tools::getHtmlTop('', '', '', we_html_element::jsScript(JS_DIR . 'customizeValidation.js') . $jsCmd->getCmds(), we_html_element::body(['class' => 'weDialogBody'], '<form name="we_form" onsubmit="return false;">' .
		we_html_multiIconBox::getHTML('weDocValidation', $parts, true, we_html_button::position_yes_no_cancel(we_html_button::create_button(we_html_button::SAVE, "javascript:we_cmd('customValidationService','saveService');", '', '', (empty($services))), we_html_button::create_button(we_html_button::CANCEL, "javascript:we_cmd('close');")), -1, '', '', false, g_l('validation', '[adjust_service]'))
		. '</form>'
));
