<?php
/**
 * webEdition CMS
 *
 * $Rev: 15107 $
 * $Author: mokraemer $
 * $Date: 2018-03-22 16:32:07 +0100 (Thu, 22 Mar 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
require_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we.inc.php');

switch($cmd = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 0)){
	case 'checkForToptLogin':
		$cnt = f('SELECT COUNT(1) FROM ' . FAILED_LOGINS_TABLE . ' WHERE UserTable="tblUser" AND IP="' . $GLOBALS['DB_WE']->escape($_SERVER['REMOTE_ADDR']) . '" AND LoginDate>(NOW() - INTERVAL ' . intval(we_base_constants::LOGIN_FAILED_TIME) . ' MINUTE)');
		$username = we_base_request::_(we_base_request::STRING, 'user');
		$hasTopt = f('SELECT TOTP!="" FROM ' . USER_TABLE . ' WHERE IsFolder=0 AND username="' . $DB_WE->escape($username) . '"');

		if($hasTopt === null){
			we_users_user::logLoginFailed('tblUser', $username);
		}

		echo json_encode(
			($hasTopt === null || $cnt >= we_base_constants::LOGIN_FAILED_NR ? ['error' => 'denied'] : ['hasTopt' => intval($hasTopt)]));
		return;
	case 'open_wysiwyg_window':
	case 'writeBack_inlineFalse':
	case 'open_dialog_abbr':
	case 'open_dialog_acronym':
	case 'open_dialog_lang':
	case 'open_dialog_gallery':
	case 'open_dialog_image':
	case 'update_dialog_image':
	case 'open_dialog_hyperlink':
	case 'open_dialog_fullscreen':
		$noInternals = we_base_request::_(we_base_request::BOOL, 'we_dialog_args', false, 'outsideWE') ||
			we_base_request::_(we_base_request::BOOL, 'we_dialog_args', false, 'isFrontend') ||
			!isset($_SESSION['user']) || !isset($_SESSION['user']['Username']) || $_SESSION['user']['Username'] === '';

		if(!$noInternals){
			we_html_tools::protect();
		}

		switch($cmd){
			case 'open_dialog_abbr':
				echo we_dialog_abbr::getDialog($noInternals);
				return;
			case 'open_dialog_lang':
				echo we_dialog_lang::getDialog($noInternals);
				return;
			case 'open_dialog_acronym':
				echo we_dialog_acronym::getDialog($noInternals);
				return;
			case 'open_dialog_gallery':
				echo we_dialog_gallery::getDialog($noInternals);
				return;
			case 'open_dialog_image':
			case 'update_dialog_image':
				echo we_dialog_image::getDialog($noInternals);
				return;
			case 'open_dialog_hyperlink':
				echo we_dialog_hyperlink::getDialog($noInternals);
				return;
			case 'open_dialog_fullscreen':
				echo we_dialog_wysiwyg::getDialog($noInternals/* , we_wysiwyg_editor::TYPE_FULLSCREEN */);
				return;
			case 'open_wysiwyg_window':
			case 'writeBack_inlineFalse':
				echo we_dialog_wysiwyg::getDialog(false/* , we_wysiwyg_editor::TYPE_INLINE_FALSE */);
				return;
		}
		return;
	default:
		exit();
}
